#include <GUIConstants.au3>
Opt("GUIOnEventMode", 1)

Global Const $PORT = 31758
Global $list, $sock
Global $userlist[17][2]		; [ index ][ username, ctrl id ]

TCPStartUp()

Global $user = "juan" ; Modificado
$gui = GUICreate("Login", 260, 100)
GUICtrlCreateLabel("Server IP", 10, 10, 60, 20)
GUICtrlCreateLabel("Username", 10, 40, 60, 20)
$ipctrl = GUICtrlCreateInput(@IPADDRESS1, 80, 10, 170, 20)
$userctrl = GUICtrlCreateInput("", 80, 40, 170, 20)
$login = GUICtrlCreateButton("Login", 170, 70, 80, 20, $BS_DEFPUSHBUTTON)

GUICtrlSetOnEvent($login, "_Login")
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

GUISetState()
$loop = True

While $loop
   Sleep(20)
WEnd

$gui = GUICreate("Client - " & $user, 460, 230)
$list = GUICtrlCreateListView("         Users       ", 350, 10, 100, 210)
$edit = GUICtrlCreateEdit("", 10, 70, 330, 150, $ES_READONLY + $WS_VSCROLL + $ES_AUTOVSCROLL)
$input = GUICtrlCreateInput("", 10, 10, 330, 20)
$send = GUICtrlCreateButton("Send", 10, 40, 80, 20, $BS_DEFPUSHBUTTON)
$pm = GUICtrlCreateButton("PM", 100, 40, 80, 20)

GUICtrlSetOnEvent($send, "_Send")
GUICtrlSetOnEvent($pm, "_PM")
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

GUICtrlSetState($input, $GUI_FOCUS)
GUISetState()

_ReduceMemory()

While 1
   Sleep(0)
   $recv = TCPRecv($sock, 2048)
   If @error Then mError("Connection lost.", 1)
   If not $recv Then ContinueLoop
   ; parse the command(s)
   $recv = StringSplit($recv, Chr(1))
   For $i = 1 to $recv[0]
	  $temp = StringSplit($recv[$i], Chr(2))
	  Switch $temp[1]
		 Case "rejected"
			mError("Connection rejected.", 1)
		 Case "kick"
			mError("Connection kicked.", 1)
		 Case "accepted"
			If $USER = "admin" Then
			   $kick = GUICtrlCreateButton("Kick", 190, 40, 80, 20)
			   GUICtrlSetOnEvent($kick, "_Kick")
			EndIf
		 Case "adduser"
			_AddUser($temp[2])
		 Case "deluser"
			_DelUser($temp[2])
		 Case "exit"
			mError("Server has closed.", 1)
		 Case Else
			If $recv[$i] Then GUICtrlSetData($edit, $recv[$i] & @CRLF, 1)
	  EndSwitch
   Next
   _ReduceMemory()
WEnd


Func _Login()
   $loop = False
   Global Const $IP = GUICtrlRead($ipctrl)
  ; Global Const $USER = GUICtrlRead($userctrl)
   $USER = GUICtrlRead($userctrl) ; Modificado
   GUIDelete($gui)
   If $USER = "admin" Then
	  Local $pass = InputBox("Enter Password:", "Please enter the server password below.", "", "")
	  If @error Then Exit
	  $sock = TCPConnect($IP, $PORT)
	  If $sock = -1 Then mError("Unable to connect.", 1)
	  TCPSend($sock, Chr(1) & $USER & Chr(2) & Hex(BinaryString(_RC4($pass, _Time()))))
   Else
	  $sock = TCPConnect($IP, $PORT)
	  If $sock = -1 Then mError("Unable to connect.", 1)
	  TCPSend($sock, $USER)
   EndIf
EndFunc

Func _Send()
   If not GUICtrlRead($input) Then Return 0
   TCPSend($sock, StringReplace(StringReplace(GUICtrlRead($input), Chr(1), ""), Chr(2), ""))
   GUICtrlSetData($input, "")
   Return 1
EndFunc

Func _PM()
   If not GUICtrlRead($input) Then Return 0
   Local $user = GUICtrlRead($list), $data = StringReplace(StringReplace(GUICtrlRead($input), Chr(1), ""), Chr(2), "")
   If not $user Then Return 0
   $user = GUICtrlRead($user)
   TCPSend($sock, Chr(1) & "PM" & Chr(2) & $user & Chr(2) & $data)
   GUICtrlSetData($input, "")
   GUICtrlSetData($edit, "<** PM sent to: " & $user & " **>" & @CRLF & "<** " & $data & " **>" & @CRLF, 1)
   Return 1
EndFunc

Func _Kick()
   Local $user = GUICtrlRead($list)
   If not $user Then Return 0
   $user = GUICtrlRead($user)
   TCPSend($sock, Chr(1) & "kick" & Chr(2) & $user)
   GUICtrlSetData($edit, "<** Kick: " & $user & " **>" & @CRLF, 1)
   Return 1
EndFunc

Func _AddUser( $user )
   If $user = "admin" and not $userlist[16][0] Then
	  $userlist[16][0] = $user
	  $userlist[16][1] = GUICtrlCreateListViewItem($user, $list)
	  Return 1
   EndIf
   For $i = 0 to 15
	  If not $userlist[$i][0] Then
		 $userlist[$i][0] = $user
		 $userlist[$i][1] = GUICtrlCreateListViewItem($user, $list)
		 Return 1
	  EndIf
   Next
   Return 0
EndFunc

Func _DelUser( $user )
   For $i = 0 to 16
	  If $userlist[$i][0] = $user Then
		 $userlist[$i][0] = ""
		 GUICtrlDelete($userlist[$i][1])
		 $userlist[$i][1] = 0
		 Return 1
	  EndIf
   Next
   Return 0
EndFunc

Func _ReduceMemory()
   DllCall("psapi.dll", "int", "EmptyWorkingSet", "long", -1)
EndFunc

Func mError( $sText, $iFatal = 0, $sTitle = "Error", $iOpt = 0 )
   Local $ret = MsgBox(48 + 4096 + 262144 + $iOpt, $sTitle, $sText)
   If $iFatal Then Exit
   Return $ret
EndFunc

Func _RC4( $sData, $sKey )   ; based on code by Valik
   Local $l[256], $i, $t, $x, $y, $s = ""
   Local $iLen = StringLen($sKey)
   For $c = 0 to 255
	  $l[$c] = $c
   Next
   For $c = 0 to 255
	  $i = Mod(Asc(StringMid($sKey, Mod($c, $iLen) + 1, 1)) + $l[$c] + $i, 256)
	  $t = $l[$c]
	  $l[$c] = $l[$i]
	  $l[$i] = $t
   Next
   For $c = 1 to StringLen($sData)
	  $x = Mod($x + 1, 256)
	  $y = Mod($l[$x] + $y, 256)
	  $t = $l[$x]
	  $l[$x] = $l[$y]
	  $l[$y] = $t
	  $s &= Chr(BitXOR(Asc(StringMid($sData, $c, 1)), $l[Mod($l[$x] + $l[$y], 256)]))
   Next
   Return $s
EndFunc

Func _Time()   ; based on code by jjohn and his time sync script
   ; 129.6.15.28 = time-a.nist.gov
   Local $conn = TCPConnect("129.6.15.28", 37), $recv = ""
   If $conn = -1 or @error Then Return SetError(1, 0, "...")
   While $recv = ""
	  $recv = TCPRecv($conn, 512)
	  If @error Then Return SetError(2, 0, "...")
   WEnd
   TCPCloseSocket($conn)
   Return StringTrimRight(Asc(StringMid($recv,1,1))*256^3+Asc(StringMid($recv,2,1))*256^2+Asc(StringMid($recv,3,1))*256+Asc(StringMid($recv,4,1)),1)
EndFunc

Func _Exit()
   Exit
EndFunc

Func OnAutoItExit()
   TCPSend($sock, Chr(1) & "bye")
   TCPShutdown()
   Exit
EndFunc

Func BinaryString ($sData)
    ;return Binary( ($sData) )
    Local $b = Binary($sData)
    Local $out = ""

    for $i=1 to BinaryLen($B)
        $out &= Chr( BinaryMid($b, $i, 1) )
    Next

    return ($out)
EndFunc