HotKeySet("{ESC}", "OnAutoItExit")

Global Const $PASS = "qwerty"

Global Const $IP = @IPADDRESS1
Global Const $PORT = 31758

Global $listen
Global $list[17][2]	; [ index ][ socket, username ]

TCPStartup()

$listen = TCPListen($IP, $PORT, 17)
If $listen = -1 Then mError("Unable to connect.", 1)

TrayTip("AU3Chat", "Server is connected on:" & @CRLF & $IP & ":" & $PORT, 15, 1)
_ReduceMemory()

While 1
   _CheckConn()
   Sleep(0)
   $sock = TCPAccept($listen)
   If $sock = -1 Then ContinueLoop
   _AddConn($sock)
   _ReduceMemory()
WEnd


Func _AddConn( $iSocket )
   ; recieve the username from the client
   Local $recv = _SockRecv($iSocket), $temp
   If @error Then
	  _DelConn($iSocket)
   Else
	  ; if they are trying to login as admin then check the password
	  If StringLeft($recv, 7) = Chr(1) & "admin" & Chr(2) Then
		 $temp = StringSplit($recv, Chr(2))
		 If _RC4(BinaryString("0x" & $temp[2]), _Time()) == $PASS and not $list[16][0] Then
			$list[16][0] = $iSocket
			$list[16][1] = "admin"
			TCPSend($iSocket, Chr(1) & "accepted")
			_SendUsers($iSocket)
			_SendAll(Chr(1) & "adduser" & Chr(2) & "admin", "", $iSocket)
			Return 1
		 Else
			TCPSend($iSocket, Chr(1) & "rejected")
		 EndIf
	  Else
		 ; find an empty space in the userlist
		 For $i = 0 to 15
			If not $list[$i][0] Then
			   $list[$i][0] = $iSocket
			   $list[$i][1] = $recv
			   TCPSend($iSocket, Chr(1) & "accepted")
			   _SendUsers($iSocket)
			   _SendAll(Chr(1) & "adduser" & Chr(2) & $recv, "", $iSocket)
			   Return 1
			EndIf
		 Next
		 ; too many users, reject the connection
		 TCPSend($iSocket, Chr(1) & "rejected")
		 TCPCloseSocket($iSocket)
	  EndIf
   EndIf
   Return 0
EndFunc

Func _DelConn( $iSocket )
   For $i = 0 to 16
	  If $list[$i][0] = $iSocket Then
		 TCPCloseSocket($iSocket)
		 $list[$i][0] = 0
		 $list[$i][1] = ""
		 Return 1
	  EndIf
   Next
   Return 0
EndFunc

Func _CheckConn()
   Local $recv = ""
   For $i = 0 to 16
	  If $list[$i][0] Then
		 $recv = TCPRecv($list[$i][0], 2048)
		 If @error Then
			; disconnect client
			TCPCloseSocket($list[$i][0])
			_SendAll(Chr(1) & "deluser" & Chr(2) & $list[$i][1])
			$list[$i][0] = 0
			$list[$i][1] = ""
		 Else
			If $recv Then
			   ; parse the command(s)
			   $recv = StringSplit($recv, Chr(1))
			   For $j = 1 to $recv[0]
				  $temp = StringSplit($recv[$j], Chr(2))
				  Switch $temp[1]
					 Case "bye"
						TCPCloseSocket($list[$i][0])
						_SendAll(Chr(1) & "deluser" & Chr(2) & $list[$i][1])
						$list[$i][0] = 0
						$list[$i][1] = ""
					 Case "kick"
						_Kick($temp[2])
					 Case "PM"
						_PM($temp[2], $temp[3], $list[$i][1])
					 Case Else
						If $recv[$j] Then _SendAll($recv[$j], $list[$i][1])
				  EndSwitch
			   Next
			EndIf
		 EndIf
	  EndIf
   Next
EndFunc

Func _SendAll( $str, $from = "", $except = 0 )
   ; send a message to all users
   For $i = 0 to 16
	  If $list[$i][0] and $list[$i][0] <> $except Then
		 If $from and StringLeft($str, 1) <> Chr(1) Then
			TCPSend($list[$i][0], $from & " > " & $str)
		 Else
			TCPSend($list[$i][0], $str)
		 EndIf
	  EndIf
   Next
EndFunc

Func _Kick( $user )
   ; kick a user and close their connection
   For $i = 0 to 15
	  If $list[$i][1] = $user Then
		 TCPSend($list[$i][0], Chr(1) & "kick")
		 TCPCloseSocket($list[$i][0])
		 $list[$i][0] = 0
		 _SendAll(Chr(1) & "deluser" & Chr(2) & $list[$i][1])
		 $list[$i][1] = ""
		 Return 1
	  EndIf
   Next
   Return 0
EndFunc

Func _PM( $user, $str, $from )
   ; private message another user
   For $i = 0 to 16
	  If $list[$i][1] = $user Then
		 TCPSend($list[$i][0], "~ " & $from & " > " & $str)
		 Return 1
	  EndIf
   Next
   Return 0
EndFunc

Func _SendUsers( $iSocket )
   ; give the userlist to a connecting client
   For $i = 0 to 16
	  If $list[$i][0] Then TCPSend($iSocket, Chr(1) & "adduser" & Chr(2) & $list[$i][1])
   Next
EndFunc

Func _SockRecv( $iSocket, $iBytes = 2048 )
   Local $sData = ""
   While $sData = ""
	  $sData = TCPRecv($iSocket, $iBytes)
	  If @error Then Return SetError(1, 0, 0)
   Wend
   Return $sData
EndFunc

Func _ReduceMemory()
   DllCall("psapi.dll", "int", "EmptyWorkingSet", "long", -1)
EndFunc

Func mError( $sText, $iFatal = 0, $sTitle = "Error", $iOpt = 0 )
   Local $ret = MsgBox(48 + 4096 + 262144 + $iOpt, $sTitle, $sText)
   If $iFatal Then Exit
   Return $ret
EndFunc

Func _RC4( $sData, $sKey )   ; based on code by Valik
   Local $l[256], $i, $t, $x, $y, $s = ""
   Local $iLen = StringLen($sKey)
   For $c = 0 to 255
	  $l[$c] = $c
   Next
   For $c = 0 to 255
	  $i = Mod(Asc(StringMid($sKey, Mod($c, $iLen) + 1, 1)) + $l[$c] + $i, 256)
	  $t = $l[$c]
	  $l[$c] = $l[$i]
	  $l[$i] = $t
   Next
   For $c = 1 to StringLen($sData)
	  $x = Mod($x + 1, 256)
	  $y = Mod($l[$x] + $y, 256)
	  $t = $l[$x]
	  $l[$x] = $l[$y]
	  $l[$y] = $t
	  $s &= Chr(BitXOR(Asc(StringMid($sData, $c, 1)), $l[Mod($l[$x] + $l[$y], 256)]))
   Next
   Return $s
EndFunc

Func _Time()   ; based on code by jjohn and his time sync script
   ; 129.6.15.28 = time-a.nist.gov
   Local $conn = TCPConnect("129.6.15.28", 37), $recv = ""
   If $conn = -1 or @error Then Return SetError(1, 0, "...")
   While $recv = ""
	  $recv = TCPRecv($conn, 512)
	  If @error Then Return SetError(2, 0, "...")
   WEnd
   TCPCloseSocket($conn)
   Return StringTrimRight(Asc(StringMid($recv,1,1))*256^3+Asc(StringMid($recv,2,1))*256^2+Asc(StringMid($recv,3,1))*256+Asc(StringMid($recv,4,1)),1)
EndFunc

Func OnAutoItExit()
   _SendAll(Chr(1) & "exit")
   TCPShutdown()
   Exit
EndFunc

Func BinaryString ($sData)
    ;return Binary( ($sData) )
    Local $b = Binary($sData)
    Local $out = ""

    for $i=1 to BinaryLen($B)
        $out &= Chr( BinaryMid($b, $i, 1) )
    Next

    return ($out)
EndFunc